Creates a new deque using a callable to determine which values to include

- « Ds\Deque::count

- Ds\Deque::find »

- PHP Manual
- Ds\Deque
- Creates a new deque using a callable to determine which values to include

# Ds\Deque::filter

(PECL ds >= 1.0.0)

Ds\Deque::filter — Creates a new deque using a callable to determine which values to include

### Description

public Ds\Deque::filter(callable `$callback` = ?): Ds\Deque

Creates a new deque using a callable to determine which values to include.

### Parameters

`callback`

  callback(mixed `$value`): bool

  Optional callable which returns `true` if the value should be included, `false` otherwise.

  If a callback is not provided, only values which are `true` (see converting to boolean) will be included.

### Return Values

A new deque containing all the values for which either the `callback` returned `true`, or all values that convert to `true` if a `callback` was not provided.

### Examples

Example #1 Ds\Deque::filter() example using callback function

    <?php$deque = new \Ds\Deque([1, 2, 3, 4, 5]);var_dump($deque->filter(function($value) {    return $value % 2 == 0;}));?>

The above example will output something similar to:

    object(Ds\Deque)#3 (2) {
      [0]=>
      int(2)
      [1]=>
      int(4)
    }

Example #2 Ds\Deque::filter() example without a callback function

    <?php$deque = new \Ds\Deque([0, 1, 'a', true, false]);var_dump($deque->filter());?>

The above example will output something similar to:

    object(Ds\Deque)#2 (3) {
      [0]=>
      int(1)
      [1]=>
      string(1) "a"
      [2]=>
      bool(true)
    }